unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles;

type
  TForm2 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Button2: TButton;
    Memo3: TMemo;
    Button3: TButton;
    Memo4: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure hotykey(var msg: TMessage);
    message WM_HOTKEY;
    procedure Apply(Lines: TStrings);
  end;

var
  Form2: TForm2;

  id1, id2, id3: Integer;

implementation


uses  ComObj;

{$R *.dfm}

procedure TForm2.Apply(Lines: TStrings);
var
  S1, S2, V, B1, B2: Variant;
  R1, R2: Integer;
  MyExcel: OleVariant;
  Sets: TStringList;
  i: Integer;
  TCol, SCol, SCol1, SCol2, s, x: String;
  TRow, SRow: Integer;
  eError: Boolean;
begin

  eError := False;

  Sets := TStringList.Create;
  Sets.AddStrings(Lines);

  try
    MyExcel := GetActiveOleObject('Excel.Application');
  except
    MyExcel := NULL;
    eError := True;
  end;

  if (not eError) then
  begin

    B1 := MyExcel.Application.Workbooks[1];
    S1 := B1.Sheets[1];
    S1.Activate;
    R1 := MyExcel.Application.ActiveCell.Row;

    B2 := MyExcel.Application.Workbooks[2];
    S2 := B2.Sheets[1];
    S2.Activate;

    Memo4.Lines.Add(Format(': %s-%s, : %s-%s',
        [B1.Name, S1.Name, B2.Name, S2.Name]));

    R2 := MyExcel.Application.ActiveCell.Row;

    for i := 0 to Sets.Count - 1 do
    begin

      if Trim(Sets[i]) = '' then
        continue;

      SCol := Trim(Sets.ValueFromIndex[i]);
      SRow := R1;
      s := Trim(Sets.Names[i]);

      if pos('+', s) > 0 then
      begin

        TCol := Copy(s, 0, pos('+', s) - 1);
        Delete(s, 1, pos('+', s));
        s := Trim(s);
        TRow := R2 + StrToInt(s);
      end
      else if pos('-', s) > 0 then
      begin

        TCol := Copy(s, 0, pos('-', s) - 1);
        Delete(s, 1, pos('-', s));
        s := Trim(s);
        TRow := R2 - StrToInt(s);
      end
      else
      begin
        TCol := s;
        TRow := R2;

      end;

      if pos('ASK(', SCol) = 1 then
      begin
        SetForegroundWindow(Handle);

        x := inputbox(' ', Copy(SCol, pos('(', SCol) + 1, pos
              (')', SCol) - pos('(', SCol) - 1), '');

        S2.Range[Format('%s%d:%s%d', [TCol, TRow, TCol, TRow])].Value := x;
        Application.Minimize;

        S2.Activate;

        Memo4.Lines.Add(Format('  %s%d  %s', [TCol, TRow, x])
          );

      end
      else
     if pos('&', SCOL) > 0 then
     begin
     SCol1 := Copy(SCol, 0, Pos('&', SCol)-1);
     SCol2 := Copy(SCol, Pos('&', SCol) + 1, 255);
     V := S1.Range[Format('%s%d:%s%d', [SCol1, SRow, SCol1, SRow])].Value + ', ' + S1.Range[Format('%s%d:%s%d', [SCol2, SRow, SCol2, SRow])].Value;
     S2.Range[Format('%s%d:%s%d', [TCol, TRow, TCol, TRow])].Value := V;
        Memo4.Lines.Add(Format('  %s%d   %s%d  %s%d (%s)',
            [TCol, TRow, SCol1, SRow, SCol2, SRow, VarToStr(V)]));
     end
     else

      begin
        V := S1.Range[Format('%s%d:%s%d', [SCol, SRow, SCol, SRow])];
        S2.Range[Format('%s%d:%s%d', [TCol, TRow, TCol, TRow])] := V;
        Memo4.Lines.Add(Format('  %s%d   %s%d (%s)',
            [TCol, TRow, SCol, SRow, VarToStr(V.Value)]));
      end;

    end;

  end
  else
  begin
    SetForegroundWindow(Handle);
    MessageBox(Handle, 'Excel       !', '',
      MB_ICONWARNING + MB_OK);
  end;

  Sets.Free;

end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Apply(Memo1.Lines);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Apply(Memo2.Lines);
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  Apply(Memo3.Lines);
end;

procedure TForm2.FormActivate(Sender: TObject);
var ini: TIniFile;
begin
  onactivate := nil;


  ini := TIniFile.Create(Application.ExeName + '.ini');
  edit1.Text :=  ini.ReadString('main', 'text_1', edit1.Text);
  edit2.Text :=  ini.ReadString('main', 'text_2', edit2.Text);
  edit3.Text :=  ini.ReadString('main', 'text_3', edit3.Text);
  ini.Free;

  if FileExists(Application.ExeName + '.1.txt') then
  begin
    Memo1.Lines.LoadFromFile(Application.ExeName + '.1.txt');
  end;

  if FileExists(Application.ExeName + '.2.txt') then
  begin
    Memo2.Lines.LoadFromFile(Application.ExeName + '.2.txt');
  end;

  if FileExists(Application.ExeName + '.3.txt') then
  begin
    Memo3.Lines.LoadFromFile(Application.ExeName + '.3.txt');
  end;

  id1 := GlobalAddAtom('helperhotkey1');
  RegisterHotKey(Handle, id1, mod_control, VK_NUMPAD1);
  id2 := GlobalAddAtom('helperhotkey2');
  RegisterHotKey(Handle, id2, mod_control, VK_NUMPAD2);
  id3 := GlobalAddAtom('helperhotkey3');
  RegisterHotKey(Handle, id3, mod_control, VK_NUMPAD3);

  if paramstr(1) = '1' then
  begin
    Apply(Memo1.Lines);
    Close;
  end
  else

    if paramstr(1) = '2' then
  begin
    Apply(Memo2.Lines);
    Close;
  end
  else

    if paramstr(1) = '3' then
  begin
    Apply(Memo3.Lines);
    Close;
  end;



end;

procedure TForm2.FormDestroy(Sender: TObject);
var ini: TIniFile;
begin
  Memo1.Lines.SaveToFile(Application.ExeName + '.1.txt');
  Memo2.Lines.SaveToFile(Application.ExeName + '.2.txt');
  Memo3.Lines.SaveToFile(Application.ExeName + '.3.txt');
  UnregisterHotKey(Handle, id1);
  UnregisterHotKey(Handle, id2);
  UnregisterHotKey(Handle, id3);

  ini := TIniFile.Create(Application.ExeName + '.ini');
  ini.WriteString('main', 'text_1', edit1.Text);
  ini.WriteString('main', 'text_2', edit2.Text);
  ini.WriteString('main', 'text_3', edit3.Text);
  ini.Free;



end;

procedure TForm2.hotykey(var msg: TMessage);
begin
  if (msg.LParamHi = VK_NUMPAD1) then
  begin
    Apply(Memo1.Lines);
  end;

  if (msg.LParamHi = VK_NUMPAD2) then
  begin
    Apply(Memo2.Lines);
  end;

  if (msg.LParamHi = VK_NUMPAD3) then
  begin
    Apply(Memo3.Lines);
  end;

end;

end.
